<template>
  <q-modal
    :value="isActive"
    @hide="$emit('close')"
  >
    <div class="q-pa-md" v-if="editor">
      <div class="q-title">Edit <b>{{ editor.title}}</b> editor fields</div>
      <q-list class="q-mt-md">
        <div v-if="editor.fields.length">
          <draggable
            :list="editor.fields"
            handle=".editor-field__drag-handle"
          >
            <q-item
              v-for="(field, index) in editor.fields"
              :key="index"
            >
              <field
                :field="field"
                @remove="removeField(index)"
                @edit="editField(index)"
                :available-fields="availableFields"
              />
            </q-item>
          </draggable>
        </div>
        <div
          v-else
          class="text-grey text-italic q-pa-sm"
        >
          No added fields. Click button below to add one
        </div>
      </q-list>
      <q-btn
        icon="add"
        label="Add field"
        color="green"
        class="q-mt-md"
        @click="addField"
      />
      <field-editor
        :field="editor.fields[editingFieldIndex]"
        @close="editingFieldIndex = null"
        parent-type="editor"
      />
    </div>
  </q-modal>
</template>

<script>
  import { defaultCollectionEditorField } from '../../../../../../utilities/migrateConfig';
  import Field from './field';
  import FieldEditor from './fieldEditor';

  export default {
    name: 'editorEditor',
    components: { FieldEditor, Field },
    props: {
      isActive: Boolean,
      editor: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    data() {
      return {
        editingFieldIndex: null,
      };
    },
    methods: {
      removeField(index) {
        this.editor.fields.splice(index, 1);
      },
      editField(index) {
        this.editingFieldIndex = index;
      },
      addField() {
        this.editor.fields.push({ ...defaultCollectionEditorField });
      },
    },
  };
</script>
